Last Comment Bug 703198 - JAWS doesn't announce combobox navigation in collapsed combobox
: JAWS doesn't announce combobox navigation in collapsed combobox
Status: RESOLVED FIXED
[qa-]
: access
Product: Core
Classification: Components
Component: Disability Access APIs (show other bugs)
: unspecified
: x86 Windows 7
-- normal (vote)
: mozilla11
Assigned To: alexander :surkov
:
: alexander :surkov
Mentors:
Depends on:
Blocks: 673958
  Show dependency treegraph
 
Reported: 2011-11-16 22:33 PST by alexander :surkov
Modified: 2012-02-01 14:00 PST (History)
3 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed


Attachments
patch (1.10 KB, patch)
2011-11-16 22:33 PST, alexander :surkov
mzehe: review+
Details | Diff | Splinter Review
patch2 (1.18 KB, patch)
2011-11-23 03:21 PST, alexander :surkov
mzehe: review+
Details | Diff | Splinter Review
combined patch (1.09 KB, patch)
2011-11-24 21:40 PST, alexander :surkov
christian: approval‑mozilla‑aurora+
Details | Diff | Splinter Review

Description User image alexander :surkov 2011-11-16 22:33:53 PST
Created attachment 575099 [details] [diff] [review]
patch

regression from bug 673958. JAWS expects focus event for changed option. Similar to Orca. I contacted to FS to check if they can do IE way for Firefox (i.e. based on value change events), that's should be consistent across browsers and ATs (NVDA picks up value change event well). In either way I think we should add a hook for JAWS to keep it working.
Comment 1 User image Marco Zehe (:MarcoZ) 2011-11-16 23:44:47 PST
Comment on attachment 575099 [details] [diff] [review]
patch

r=me, even though I think this is rather hacky. ;) But at least it will get JAWS working with those comboboxes.
Comment 2 User image alexander :surkov 2011-11-16 23:48:29 PST
(In reply to Marco Zehe (:MarcoZ) from comment #1)
> Comment on attachment 575099 [details] [diff] [review] [diff] [details] [review]
> patch
> 
> r=me, even though I think this is rather hacky. ;) But at least it will get
> JAWS working with those comboboxes.

absolutely, in bug 673958 we ended up that we shouldn't fire focus event for options when they aren't visible so I do this for JAWS only. Marco, would you mind to check how other screen readers feel about that like WE or Supernova?
Comment 3 User image alexander :surkov 2011-11-21 21:04:20 PST
inbound land https://hg.mozilla.org/integration/mozilla-inbound/rev/8914d038bd09
Comment 4 User image Ed Morley [:emorley] 2011-11-22 09:08:25 PST
https://hg.mozilla.org/mozilla-central/rev/8914d038bd09
Comment 5 User image alexander :surkov 2011-11-22 19:55:31 PST
Comment on attachment 575099 [details] [diff] [review]
patch

need to be ported into Firefox 10 where regression was introduced (bug 673958). The bug prevents JAWS (major screen reader) to work with comboboxes. Patch is trivial, the code is JAWS specific (nobody else is affected).
Comment 6 User image Ed Morley [:emorley] 2011-11-23 02:19:56 PST
I believe this is responsible for various a11y MozAfterPaint regressions on dev.tree-management:
http://graphs-new.mozilla.org/graph.html#tests=[[113,63,1],[113,63,12],[113,131,1]]&sel=1321910662231.955,1322043257360&displayrange=7&datatype=running
Comment 7 User image alexander :surkov 2011-11-23 02:24:01 PST
then it means ::GetModuleHandleW() call is high expensive
Comment 8 User image alexander :surkov 2011-11-23 02:24:38 PST
Comment on attachment 575099 [details] [diff] [review]
patch

canceling request until perf problems are figured out
Comment 9 User image alexander :surkov 2011-11-23 03:21:12 PST
Created attachment 576441 [details] [diff] [review]
patch2

let's see if it helps
Comment 10 User image Marco Zehe (:MarcoZ) 2011-11-23 03:56:04 PST
Comment on attachment 576441 [details] [diff] [review]
patch2

r=me. Good idea to switch these checks around so the ::getModuleHandle call doesn't get executed each time.
Comment 11 User image alexander :surkov 2011-11-23 08:26:44 PST
inbound land (patch2) https://hg.mozilla.org/integration/mozilla-inbound/rev/c7a66776a891
Comment 13 User image Ed Morley [:emorley] 2011-11-23 09:05:29 PST
Great, thanks! :-)
Comment 14 User image Matt Brubeck (:mbrubeck) 2011-11-23 10:15:00 PST
https://hg.mozilla.org/mozilla-central/rev/c7a66776a891
Comment 15 User image alexander :surkov 2011-11-23 21:16:10 PST
Comment on attachment 576441 [details] [diff] [review]
patch2

see comment #5 (perf regression is fixed)
Comment 16 User image Marco Zehe (:MarcoZ) 2011-11-23 23:41:10 PST
Alex, you might want to put up a unified patch for Aurora that just shows the diffs against the current Aurora code. This patch2 depends on patch1, which is confusing, esp if none of us ends up transplanting the patch in case we get approval. So my recommendation is to make a patch specific to Aurora that only contains the fixed version of the code, and request approval for that.
Comment 17 User image alexander :surkov 2011-11-24 21:40:38 PST
Created attachment 576870 [details] [diff] [review]
combined patch
Comment 18 User image Marco Zehe (:MarcoZ) 2011-11-29 01:03:23 PST
Pushed to Aurora on Alexander's behalf: http://hg.mozilla.org/releases/mozilla-aurora/rev/d36cab2ac025
Comment 19 User image alexander :surkov 2011-11-29 02:32:32 PST
Thanks, Marco!
Comment 20 User image Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2011-12-28 13:48:04 PST
Is this something QA can verify?
Comment 21 User image alexander :surkov 2012-01-20 06:47:38 PST
(In reply to Anthony Hughes, Mozilla QA (irc: ashughes) from comment #20)
> Is this something QA can verify?

yeah, you need JAWS for this though. If you have JAWS running then you should tab into HTML select (combobox) and then arrow down through its options. If JAWS reads them then bug is fixed.
Comment 22 User image Anthony Hughes (:ashughes) [GFX][QA][Mentor] 2012-01-20 11:36:39 PST
Unfortunately, this is not something I'm set up to test. For now I will mark this qa- in the hopes that someone from the community can help verify this fix.

Note You need to log in before you can comment on or make changes to this bug.